#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Fri 07 May 2010 10:04:20 AM CST

''' nas '''

import os

from system import getgid
from system import ADMIN
from system import REALPUBLIC
from system import _mkdir
from system import chown
from system import set_name_value
from system import makesure_nasdir
from system import check_session

import pwd
from users import _adduser

from daap import DAAPCONF
from dlna import DLNACONF

def check_admin():
    ''' check for admin account
    '''
    try:
        pwd.getpwnam(ADMIN)
    except KeyError:
        _adduser('admin', 'admin', 'Administrator')

gid = getgid('nas')
def check_public():
    ''' check for public directory
    '''
    mask = os.umask(002)
    UPLOAD = os.path.join(REALPUBLIC, 'upload')

    _mkdir(REALPUBLIC)
    chown(REALPUBLIC, 0, gid)

    _mkdir(UPLOAD)
    os.umask(mask)
    try:
        ftp = pwd.getpwnam('ftp')
        ftpuid = ftp.pw_uid
    except KeyError:
        ftpuid = 0
    chown(UPLOAD, ftpuid, gid)

def check_logfile():
    names = {'db_dir': '/home/.nas',
             'always_scan': '0',        # very important !
             'logfile': '/home/.nas/mt-daapd.log'}
    set_name_value(DAAPCONF, names, ['#'], '\t')

    names = {'db_dir': '/home/.nas',
             'log_dir': '/home/.nas'}
    set_name_value(DLNACONF, names, ['#'], '=')

try:
    makesure_nasdir()
    check_session()
    check_admin()
    check_public()
except:
    pass
# check_logfile()

# vim: set sta sw=4 et:
