#!/usr/bin/env python
#fileencoding: utf-8
#Author: Liu DongMiao <liudongmiao@gmail.com>
#Created  : Wed 05 May 2010 01:02:20 PM CST

import os
from system import fixperm
from system import NASError
from webdav import StatusComplete
from login import updatetime

LOGS = {'boot': '/var/log/dmesg',
        'system': '/var/log/messages',
        'webserver': '/dev/null',
        'samba': '/dev/null',
        'daap': '/home/.nas/mt-daapd.log',
        'ftps': '/dev/null',
        'dlna': '/home/.nas/minidlna.log',
        'mldonkey': '/home/downloads/mldonkey.log',
        }

def getlog(cat=None, url=None, **kw):
    if cat is None:
        if url is None:
            raise NASError('Bad Request')

        # /nas/session/cat.log
        paramlist = url.split('/') # ['', 'nas', 'session', 'cat.log']
        if len(paramlist) != 4:
            raise NASError('Bad Request')

        session = paramlist[2]
        cat = paramlist[3]
        updatetime(session)

    cat = str(cat)
    if cat.endswith('.log'):
        cat = cat[:-4]

    if cat not in LOGS:
        raise NASError('Bad Request')

    try:
        os.stat(LOGS[cat])
    except os.error:
        filename = '/dev/null'
    else:
        filename = LOGS[cat]
        fixperm(filename)

    status = 200
    headers = [('Content-Type', 'text/plain; charset=utf8'),
               ('X-Sendfile', filename)]
    raise StatusComplete(status, headers)

def clearlog(cat=None, **kw):
    if cat is None:
        raise NASError('Bad Request')

    cat = str(cat)

    if cat not in LOGS:
        raise NASError('Bad Request')

    name = LOGS[cat]
    if name != '/dev/null' and os.path.exists(name):
        fp = open(name, 'w')
        fp.write('')
        fp.close()

    parent, child = os.path.split(LOGS[cat])
    for files in os.listdir(parent):
        if files.startswith(child) and files != child:
            try:
                os.unlink(files)
            except os.error:
                pass

    return {'clear': 'clear %s log' % cat}

__all__ = ['getlog', 'clearlog']

# vim: set sta sw=4 et:
