﻿$(function(){
	window.App="MyNAS";
	layout();
	bindEvent();
	loadLang();
	loadData();	
});



function layout(){
	$("#users").append("<table id='userlist'></table");
	$("#userlist").flexigrid({
		singleSelect:true
		,colModel : [
				{display: '<label domain="l10n" msgid="MyMAS_upload_grid_operation"></label>', name : 'operation', width : 60, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="MyNAS_share_text_shareto"></label>', name : 'guest', width : 120, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="global_text_readonly"></label>', name : 'readonly', width : 40, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="global_text_readwrite"></label>', name : 'fullcontrol', width : 40, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="MyNAS_share_text_expire"></label>', name : 'expire', width : 80, sortable : false, align: 'left'}
				,{display: '<label domain="l10n" msgid="MyNAS_share_text_path"></label>', name : 'path', width : 600, sortable : false, align: 'left'}
				]
	});	
	$(window).resize();
	$('body').layout({ 
			center__paneSelector:"#main"
		,	north__paneSelector:"#top"  
		,	north__size:40
		,	north__spacing_open:0
		,	south__paneSelector:"#bottom"  
		,	south__size:60
		,	south__spacing_open:0
		,	contentSelector:".data"
		,	center__onresize_end: function(){ $(window).resize(); }
	}); 
}



function bindEvent(){
	$("#ADD").click(function(){ $('#dialog').show(); })
	$("#CLOSE").click(function(){ $('#dialog').hide();$('#sharename , #limittime').val(''); })
	$("#ADDITEM").click(function(){toAdd();})	
	$("#receiver").click(function(){window.top.System.addReceiver({app:window.top.MyNAS, data:'email', fn:addReceiver});})	
	$("#limittime").datepicker({ dateFormat: 'yymmdd' });
	$("#everyone").click(function(){noSend();});
	$("#REFRESH").click(function(){loadData();})
	$("#CANCEL").click(function(){window.win.closeWin();})
}


function noSend(){
	if($("#everyone").is(':checked')){
		$('#sharename').val('everyone').attr('disabled','disabled');
		$('#receiver').hide();
	}else{
		$('#sharename').val('').removeAttr('disabled');
		$('#receiver').show();		
	}
}


function loadData(){
	var path=window.win.fromWinObject.path; 
	$("#path")[0].path=path;
	try {var p=decodeURIComponent(path);}
	catch(e){var p=path;}	
	$("#path").html(p);
	
	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/publish"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:path
			,guest:''
			,expire:'0'
			,rw:''
			}
		,type: "POST"
		,dataType:"xml"
		,traditional:true
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});
}

function parseData(data){	
	$("#userlist tr").remove();
	var dl=window.top.location.protocol+"//"+window.top.NASinfo.registername+'.'+$.l10n.__('global_link_domainname');
	
	
	$('record',data).each(function(){
		var uuid=$('uuid',this).text();				   
		var rw=$('rw',this).text();
		var guest=$('guest',this).text();
		var expiredate=$('expire',this).text();	
		var path=dl+'/publish.html?uuid='+uuid;
		var path='<a href="'+path+'" target="_blank" class="link">'+path+'</a>';
		
		$("#userlist")[0].grid.addRow({
			id:uuid
			,operation:''
			,guest:guest
			,readonly:'<input type="radio" name="'+uuid+'">'
			,fullcontrol:'<input type="radio" name="'+uuid+'">'
			,expire:''
			,path:path
		});
		
		var $tr=$('#userlist tr#'+uuid);
		$tr.attr('guest',guest);
		
		var tr=$tr[0];
		var rd_readonly=$('input[type=radio]:first',tr)[0];//document.createElement('input');
		var rd_fullcontrol=$('input[type=radio]:last',tr)[0];//document.createElement('input');
		rd_readonly.type=rd_fullcontrol.type='radio';
		rd_readonly.value='no';
		rd_fullcontrol.value='yes'; 
		var edit=document.createElement('a');
			edit.className='icon s12 edit';		
		var del=document.createElement('a');
			del.style.display='none';
			del.className='icon s12 remove';		
		var save=document.createElement('a');
			save.style.display='none';
			save.className='icon s12 save';	
		var expire=document.createElement('input');
			expire.type='text';
			expire.disabled='disabled';
			expire.value=expiredate;
			$(expire).datepicker({ dateFormat: 'yymmdd' });
	
		
		$("td[_name='operation'] div",tr).append(edit).append(del).append(save);
		$("td[_name='readonly'] div",tr).append(rd_readonly);
		$("td[_name='fullcontrol'] div",tr).append(rd_fullcontrol);
		$("td[_name='expire'] div",tr).append(expire);		
		
		if(rw==="yes")$(rd_fullcontrol).attr('checked','checked');
		else $(rd_readonly).attr('checked','checked'); 
		rd_readonly.disabled=rd_fullcontrol.disabled='disabled'; 
	
			
		tr.$edit=$(edit);
		tr.$del=$(del);
		tr.$save=$(save);
		tr.$rw=$('input[type=radio]',tr);
		tr.$expire=$(expire);	
		tr.guest=guest;
		tr.rw=rw;
		
		$(del).click(function(){toDelete(tr);});
		$(save).click(function(){toSave(tr);});
		
		
		$tr.click(function(){
			if( $('#userlist tr.editing').length>0&& $('#userlist tr.editing')[0]!==tr){
				$('#userlist tr.editing').click();
				$tr.click();
			}
			if($tr.hasClass('trSelected')){
				$tr.addClass('editing');
				tr.$edit.hide();
				tr.$save.show().css({display:'inline-block'});
				tr.$del.show().css({display:'inline-block'});
				tr.$expire.removeAttr('disabled');
				tr.$rw.removeAttr('disabled');
			}
			else{
				$tr.removeClass('editing');
				tr.$edit.show().css({display:'inline-block'});
				tr.$save.hide();
				tr.$del.hide();
				tr.$expire.attr('disabled','disabled');
				tr.$expire.val(expiredate);
				tr.$rw.attr('disabled','disabled');	
				if(tr.rw=="yes")$(rd_fullcontrol).attr('checked','checked');
				else $(rd_readonly).attr('checked','checked');
			}
		});
		
	})	;
}




function toAdd(){
	if(!toValidate())return;
	$('#userlist tr.editing').click();
	
	var namearr=$("#sharename").val().split(",");	
	var limit=$("input[name='limit']:checked").val();	
	var limittime=$("#limittime").val();
	var limitarr=[],limittimearr=[];
	var guests=[];
	for(var i=0;i<namearr.length;i++){
		var n=namearr[i].replace(/\s/g,'');
		if( $.inArray(n,guests)===-1 && n!==''){
			guests.push(n);
			limitarr.push(limit);
			limittimearr.push(limittime);
		}
	}
	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/publish"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:$("#path").text()
			,guest:guests
			,expire:limittimearr
			,rw:limitarr
			}
		,type: "POST"
		,dataType:"xml"
		,traditional:true
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;			
			toRefresh();
			parseData(data);
			toSendMessages(guests);
			$('#dialog').hide();
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});		
			
}




function toSave(tr){
	var path=$("#path").html();
	var guest=tr.guest;
	var rw=$('input:checked',tr).val(); 
	var expire=tr.$expire.val();
	if(!toValidadeExpire(expire))return;
	
	$.ajax({
			url: window.top.remoteDataUrl+"nas/publish"
			,cache:false
			,data:{
				hash:window.top.SessionID
				,path:path
				,guest:guest
				,expire:expire
				,rw:rw
				}
			,type: "POST"
			,dataType:"xml"
			,traditional:true
			,success: function(data){
				$("#waiting").hide();
				if(window.top.checkAPIError(data))return;
				parseData(data);
			}		
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}
		});	
}



function toDelete(tr){
	if(!confirm($.l10n.__('MyNAS_share_alert_delshare'))) return;
	var path=$("#path").html();
	var guest=tr.guest;
	var expire=tr.$expire.val();
	
	$("#waiting").show();
	$.ajax({
		url: window.top.remoteDataUrl+"nas/publish"
		,cache:false
		,data:{
			hash:window.top.SessionID
			,path:path
			,guest:guest
			,expire:'0'
			,rw:''
		}
		,type: "POST"
		,dataType:"xml"
		,traditional:true
		,success: function(data){
			$("#waiting").hide();
			if(window.top.checkAPIError(data))return;			
			toRefresh();
			parseData(data);
		}		
		,error:function(data){
			$("#waiting").hide();
			alert ( $.l10n.__("global_alert_getdataerror") );
		}
	});				
}


function toSendMessages(guests){
	if($("#everyone").is(':checked'))return;
	for(var i=0;i<guests.length;i++){
		var guest=guests[i];
		toSendMessage(guest);
	}
}


function toSendMessage(guest){
	$("#waiting").show();
	var uuid=$('#userlist tr[guest="'+guest+'"]').attr('id');
	if(!uuid)return;
	var dl=window.top.location.protocol+"//"+window.top.NASinfo.registername+'.'+$.l10n.__('global_link_domainname');
	var path=dl+'/publish.html?uuid='+uuid;
	var content='<a href="'+path+'">'+path+'</a>';
	if(guest.indexOf('@')>-1){
		$.ajax({
			url: window.top.remoteDataUrl+"nas/send/email"
			,cache:false
			,async:false
			,data:{
				hash:window.top.SessionID
				,subject:"Sharings from my NAS!"
				,body:content
				,sender:window.emailSender||window.top.user
				,receiver:guest
			}
			,type: "POST"
			,dataType:"xml"		
			,success: function(data){
				$("#waiting").hide();
				if(window.top.checkAPIError(data))return;
			}
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}		
		});		
	}else{
		$.ajax({
			url: window.top.remoteDataUrl+"nas/send/sms"
			,cache:false
			,async:false
			,data:{
				hash:window.top.SessionID
				,msg:content
				,dest:guest
			}
			,type: "POST"
			,dataType:"xml"		
			,success: function(data){
				$("#waiting").hide();		
				if (window.top.checkAPIError(data)) return;
			}
			,error:function(data){
				$("#waiting").hide();
				alert ( $.l10n.__("global_alert_getdataerror") );
			}
		});		
	}
}


function addReceiver(r){	
	var v=$("#sharename").val();
	$("#sharename").val(  v + ( (/,$/.test(v)||v==='')?'':',') + r.join(',') );
}



function check(receiveArray,checkItem){
       var index=-1;
       for(var i=0;i<receiveArray.length;i++){
	   	   if(receiveArray[i]==checkItem){
		   	  index=i;
			  break;
		   }
	   }
	   return index;
}




function getSender(){
	$.ajax({
	   url: window.top.root+'home/.email.conf'
	   ,type: "GET"
	   ,cache:false
	   ,data: {
		   hash:window.top.SessionID
		}
	   ,cache: false
	   ,dataType: "xml"
	   ,success: function(data){
		   window.emailSender=$('sender',data).text();
		}
		,error:function(data){
		}			
	   //,timeout: 10000
	 });
}




function toValidate(){
	
	if(!toValidadeExpire($('#limittime').val()))return;
	
	var fields = [
		{
			method : 'required',
			value : $('#sharename').val(), 
			element : $('#sharename')[0],
			param : null, 
			errParam : $.l10n.__('MyNAS_share_text_shareto')
		}
		,{
			method : 'required',
			value : $('#limittime').val(), 
			element : $('#limittime')[0],
			param : null, 
			errParam : $.l10n.__('MyNAS_share_text_expire')
		}
		];
		return validateFields(fields);
}

function toValidadeExpire(v){
	var st=window.top.Dean.OS.Desktop.getSystemDateTime();
	var t=[v.slice(0,4),v.slice(4,6),v.slice(6,8)];
	t=t.join('/'); 
	t=new Date(t);
	if(t<=st){
		alert($.l10n.__('MyNAS_share_alert_expire'));
		return false;
	}
	return true;
}


function toRefresh(){
		if(window.win.fromWinObject.fn)window.win.fromWinObject.fn.apply();
}